#!/usr/bin/perl
#=====================================================================================
# Note:
#   Need to have the initial caller provide some more information that can be 
#   placed in the JavaScript calls to preserve during a help dialog.
#
#     Tool       - name of tool (e.g. Journal or Planner)
#     Copyright  - copyright notice displayed at bottom of every page
#
#=====================================================================================
# Change History:
#
# Date       Name/Change
# ---------- -------------------------------------------------------------------------
# 2011-03-07 eat - clean up for release
#=====================================================================================
use CGI qw(:standard);

sub getCertUserId{
  return($ENV{SSL_CLIENT_S_DN_CN}) if($ENV{SSL_CLIENT_S_DN_CN}); # apache mod_ssl
  return($ENV{CLIENT_CERT_SUBJECT_CN}) if($ENV{CLIENT_CERT_SUBJECT_CN}); # Sun One iPlanet
  return('guest'); # Temp - while running without certificates
  }

sub createIndex{
  (my $type)=@_;
  $pattern="^(.*?)\\\.$type\$";
  $verb=$type;
  $verb='edit' if($type eq 'help');
  opendir(DIR,"help");
  @file=sort(readdir(DIR));
  @filedesc=reverse(@file);
  closedir(DIR);
  print("<table><tr><td>\n");
  #print("<a href='nbhelp.cgi?request=$verb;page=$page;'>$page</a><br>\n");
  foreach $file (@filedesc){
    if($file=~$pattern){
      $name=$1;
      next if($name gt $page);
      print("<a href='nbhelp.cgi?request=$verb;page=$name;'>$name</a><br>\n");
      }
    }
  print("</td><td>\n");
  foreach $file (@file){
    if($file=~$pattern){
      $name=$1;
      next if($name le $page);
      print("<a href='nbhelp.cgi?request=$verb;page=$name;'>$name</a><br>\n");
      }
    }
  print("</td></tr></table>\n");
  }

# Print heading
print("Content-type: text/html\n\n");
print("<html><head><title>nbHelp</title>\n");
# replace this with a load of the user's style - see code in Journal.cgi
print("<link rel='stylesheet' title='help_style' href='/style/nbhelp.css' type='text/css'/>
<meta http-equiv='Default-Style' content='help_style'/>
");
print("<script language=\"JavaScript\" type=\"text/javascript\">\n");
print("<!--\n");
print("//-->\n");
print("</script>\n");
print("</head>\n<body marginwidth='0' marginheight='0' leftmargin='0' topmargin='0'>\n");

$request=param('request');
if(!$request){
  $page=$ENV{QUERY_STRING};
  $file="help/$page.help";
  $edit=0;
  $userId=getCertUserId();
  }
else{
  $page=param('page');
  $next=param('next');
  $prior=param('prior');
  $up=param('up');
  $title=param('title');
  $text=param('text');
  if($request eq 'edit'){
    $file="help/$page.help";
    $copy='&nbsp;';
    $edit=1;
    }
  elsif($request eq 'work'){
    $file="help/$page.work";
    $copy='Work';
    $edit=1;
    }
  elsif($request eq 'last'){
    $file="help/$page.last";
    $copy='Last';
    $edit=1;
    }
  elsif($request eq 'Test'){
    $file="help/$page.work";
    $copy='Work';
    open(PAGE,">$file")||print("unable to open file\n") && exit(0);
    printf(PAGE "HEADER:$title:$next:$prior:$up\n$text");
    close(PAGE); 
    $edit=1;
    }
  elsif($request eq 'Save'){
    $file="help/$page.help";
    system("cp $file help/$page.last;rm help/$page.work");
    open(PAGE,">$file")||print("unable to open file\n") && exit(0);
    printf(PAGE "HEADER:$title:$next:$prior:$up\n$text");
    close(PAGE); 
    $edit=1;
    }
  }

if($edit){
  #print("<table width=950 border=1>\n");
  print("<table width='100%' border=1>\n");
  print("<tr><td width=400>\n");
  }

# Get header
open(PAGE,"$file");
$header=<PAGE>;
chomp($header);
($x,$title,$next,$prior,$up)=split(/:/,$header);
$up='planner' if(!$up);
print("<table width='100%' cellspacing=0 border=0 cellpadding=0 bgcolor='#000000'>
<tr><td width='46' valign='middle' bgcolor='#000000'>
<table cellpadding='0' bgcolor='#000000'>
<tr><td colspan=2><span style='font-size: 2px;'>&nbsp;</span></td></tr>
<tr><td><span style='font-size: 6px;'>&nbsp;</span></td><td valign='middle'><img src='/nb32.gif' align='absmiddle' height='32' width='32'></td>
</tr>
<tr><td colspan=2><span style='font-size: 2px;'>&nbsp;</span></td></tr>
</table>
</td>
<td align='left' valign='middle'>
<table cellpadding=0 cellspacing=0>
<tr>
<td style='font-size: 21px; font-family: arial, sans-serif; color: white'>NodeBrain</td>
<td valign='top' style='font-size: 8px; color: white'>TM</td>
<td valign='bottom' style='font-size: 16px; color: white'>Planner<span></td>
</tr>
</table>
</td>
<td width='40%' align='right' valign='middle'>
<span style='font-size: 16px; font-family: arial, sans-serif; color: white'>Help &nbsp; &nbsp;</span>
</td></tr>
<tr><td class='navbar' colspan=3 align='left'>
<table width='100%' cellpadding=0 cellspacing=0><tr><td>
&nbsp; <a href='nbhelp.cgi?planner'>Home</a> |
<a href='javascript:window.history.back()'>Back</a> |\n
<a href='javascript:window.history.forward()'>Forward</a> |\n
<a href='javascript:window.print()'>Print</a>\n
</td><td align='center'>&nbsp;
");
if($userId==94130 || $userId==191103){  # Ed and Marshall - this should be external
  print("<a href='nbhelp.cgi?request=edit;page=$page' target=helpedit>Edit</a> |
<a href='nbhelp.cgi?$page'>Refresh</a>
");
  }
print("&nbsp;</td><td align='right'>
<a href='nbhelp.cgi?$next'>Next</a> |
");
if($prior){print("<a href='nbhelp.cgi?$prior'>Prior</a> |");}
else{print("<a href='javascript:window.history.back()'>Prior</a> |");}
print("<a href='nbhelp.cgi?$up'>Up</a> &nbsp;
</td></tr></table>
</td>
</tr>
<tr><td height=1 colspan=4 bgcolor='#000000'/></tr>
</table>
");

# Print body

print("<table width='400'><tr><td height=3 colspan=4/></tr><tr><td>\n");
print("<p><span style='font-size: 12px'><b>$title</b></span>\n");

while(<PAGE>){
  print($_);
  }

#print("<hr>\n");
# Insert code to show analyst posted comments here

# Print footer

print("<hr>\n");
print("Copyright &copy; 2006-2013 The Boeing Company.<br>\n");
print("</td></tr></table>\n");
if($edit){
  #print("</td><td width='80%'>\n");
  print("</td><td width='100%'>\n");
  print("<form name='edit' action='nbhelp.cgi' method='post'>\n");
  print("<table cellpadding=0 cellspacing=0>\n");
  print("<tr><td><input type='submit' name='request' value='Save'></td>\n");
  $link='';
  $link="&nbsp; &nbsp;<a href='nbhelp.cgi?request=last;page=$page'>Previous Version</a>" if(-f "help/$page.last");
  print("<td>Page:</td><td><input type='text' name='page' value='$page' size=60>$link</td><tr>\n");
  $link='';
  $link="&nbsp; &nbsp;<a href='nbhelp.cgi?request=edit;page=$page' target=helpedit>Current Version</a>" if(-f "help/$page.help");
  print("<tr><td style=\"color:red\" align=center valign=center>$copy</td><td><a href='nbhelp.cgi?request=edit;page=$next'>Next</a>:</td><td><input type='text' name='next' value='$next' size=60>$link</td><tr>\n");
  print("<tr><td align=center valign=middle>&nbsp</td><td><a href='nbhelp.cgi?request=edit;page=$prior'>Prior</a>:</td><td><input type='text' name='prior' value='$prior' size=60></td><tr>\n");
  print("<tr><td align=center valign=middle>&nbsp</td><td><a href='nbhelp.cgi?request=edit;page=$up'>Up</a>:</td><td><input type='text' name='up' value='$up' size=60></td><tr>\n");
  print("<tr><td><input type='submit' name='request' value='Test'></td>\n");
  $link='';
  $link="&nbsp; &nbsp;<a href='nbhelp.cgi?request=work;page=$page'>Working Version</a>" if(-f "help/$page.work");
  print("<td>Title:</td><td><input type='text' name='title' value='$title' size=60>$link</td><tr>\n");
  printf("</table>\n");
  #print("<textarea name=text rows=46 cols=100>\n");
  print("<textarea name=text rows=48>\n");
  open(PAGE,"$file");
  while(<PAGE>){
    next if(/^HEADER/);
    $line=join('&amp;',split(/&/));
    print($line);
    }
  close(PAGE);
  print("</textarea>\n");
  print("</form>\n");
  print("</td></tr></table>\n");
  
  print("<table><tr><th>Working Versions</th><th>Current Versions</th></tr>\n");
  print("<tr><td>\n");
  createIndex('work');
  print("</td><td>\n");
  createIndex('help');
  print("</td></tr></table>\n");
  }
print("</body></html>\n");

exit(0);
