# NodeBrain Planner 0.8.0 (XML Schema 0.8)
#
# Name:      _Alarm
#
# Title:     Alarm Model
#
# Purpose:
#   
#   Used as model for creating new alarms.
#
# Warning:
#
#   Do not edit this file manually unless it is no longer under the control of NodeBrain Planner.
#   Otherwise, your changes will be removed by the next update.
#
# Path:      CABOODLE/plan/_Alarm
#
# Scheme:    _Alarm
#
#================================================================================================
# Permits:
#
#   Administrator (owner) <root@localhost>
#
#================================================================================================
# History:
#
# Date       Time     User - Change - Reason
# ---------- -------- ------------------------------------------------------------------------------
# 2013-04-29 14:40:38 Administrator - Full plan update - 
#================================================================================================

%use plan/Foo/Foo.nb;
%use plan/Bar/Bar.nb;
%use plan/CaboodleAlarmer/CaboodleAlarmer.nb; # Provides alarm, alarmS and alarmSS

# Avoid duplicates within a specified period
define CAB9999.tuple node tree;
define CAB9999.period on(~(2h)) ?CAB9999.tuple();

# Alarm rule
define CAB9999 if((a>7 and not b=2) && ?CAB9999.tuple(user,system)) \
  x=27,CAB9999.tuple(user,system)\
  :$ CaboodleAlarmer.alarmSS. alert ("CAB9999","users have a big problem on ${system}","${user}"),\
  severityS="major",\
  factsS="System=${system}",\
  urlS="request=query;order=System;filter=System=${system}",\
  severitySS="critical",\
  textSS="systems had $${summary._kids} users with a big problem",\
  detailSS="${system}",\
  factsSS="",\
  urlSS="",\
  facts="User=${user};System=${system}",\
  url="request=query;order=user;filter=User=${user};System=${system}",\
  group="OS",\
  severity="minor",\
  text="This is a big problem for user ${user} on ${system}",\
  route="dba,sa,dev";
