# NodeBrain Planner 0.8.0 (XML Schema 0.8)
#
# Name:      _Alarmist
#
# Title:     Model Alarmist
#
# Purpose:
#   
#   Used as model for creating new alarmist plans, which generate alarms for multiple signatures under a single alarm identifier.  This is appropriate if the response is the same for all signatures.
#
# Warning:
#
#   Do not edit this file manually unless it is no longer under the control of NodeBrain Planner.
#   Otherwise, your changes will be removed by the next update.
#
# Path:      CABOODLE/plan/_Alarmist
#
# Scheme:    _Alarmist
#
#================================================================================================
# Permits:
#
#   Administrator (owner) <root@localhost>
#
#================================================================================================
# History:
#
# Date       Time     User - Change - Reason
# ---------- -------- ------------------------------------------------------------------------------
# 2013-05-06 06:20:36 Administrator - Full plan update - 
#================================================================================================

%use plan/Foo/Foo.nb;
%use plan/Bar/Bar.nb;
%use plan/CaboodleAlarmer/CaboodleAlarmer.nb; # Provides alarm, alarmS and alarmSS

# Define signature conditions
%assert signature="CAB9999.signature";
define CAB9999.signature cell \
  ((type="blaster" and system~"^sql-") and "Foobar") or \
  ((type="littlebunny" and system~"^boppinum-") and "Foofoo") or ?;

# Avoid duplicates within a specified period
define CAB9999.tuple node tree;
define CAB9999.period on(~(2h)) ?CAB9999.tuple();

# Alarm rule
% define CAB9999 if((CAB9999.signature) && ?CAB9999.tuple(%{signature},user,system)) \
  CAB9999.tuple(%{signature},user,system)\
  :$ CaboodleAlarmer.alarmSS. alert ("CAB9999","users with ${%{signature}} on ${system}","${user}"),\
  severityS="major",\
  factsS="System=${system}",\
  urlS="request=query;order=System;filter=System=${system}",\
  severitySS="critical",\
  textSS="systems had $${summary._kids} users with ${%{signature}}",\
  detailSS="${system}",\
  factsSS="",\
  urlSS="",\
  facts="Signature=${%{signature}};User=${user};System=${system}",\
  url="request=query;order=user;filter=User=${user};System=${system}",\
  group="OS",\
  severity="minor",\
  text="${%{signature}} for user ${user} on ${system}",\
  route="dba,sa,dev";
