# NodeBrain Planner 0.8.0 (XML Schema 0.8)
#
# Name:      _Policy
#
# Title:     Model Policy
#
# Purpose:
#   
#   Used as model for policy plans. Specifies a set of rules that respond to alerts and/or assertions to the parent or specified context.
#
# Warning:
#
#   Do not edit this file manually unless it is no longer under the control of NodeBrain Planner.
#   Otherwise, your changes will be removed by the next update.
#
# Path:      CABOODLE/plan/_Policy
#
# Scheme:    _Policy
#
#================================================================================================
# Permits:
#
#   Administrator (owner) <root@localhost>
#
#================================================================================================
# History:
#
# Date       Time     User - Change - Reason
# ---------- -------- ------------------------------------------------------------------------------
# 2013-04-29 14:41:15 Administrator - Full plan update - 
# 2013-04-29 15:57:41 Ed Trettevik - Edit  - 
# 2013-04-29 15:57:41 Ed Trettevik - PlanTableAttributeEnable (Rule,...) - 
# 2013-04-29 15:58:42 Ed Trettevik - Edit  - 
# 2013-04-29 15:58:42 Ed Trettevik - PlanTableAttributeAssign (Abstract=If you can think of any helpful information about this node that is not just a repeat of the name, title, purpose and guide provided above, include it here. ) - 
# 2013-04-29 15:58:42 Ed Trettevik - PlanTableAttributeAssign (Context=) - 
# 2013-04-29 15:59:33 Ed Trettevik - Edit  - 
# 2013-04-29 15:59:33 Ed Trettevik - PlanTableRowUpdate 2 - 
#================================================================================================

# If you can think of any helpful information about this node that is not just a repeat
# of the name, title, purpose and guide provided above, include it here. 

%use plan/Foo/Foo.nb;
%use plan/Bar/Bar.nb;

# Example with assertion and command
define Policy.R1 if(a=2 and b=1) \
  c=3 \
  :-echo hello >> log/foo.log

define Policy.Bob if(a=3 or b=7) \
  c=2;

# Example with just a command
define Policy.R2 if(a>5) \
  :-echo hello >> log/foo.log

# Example with no action
define Policy.R3 if(a>29);

# Children:
